#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <Xm/XrtGear.h>
#include <Xm/XrtOutliner.h>
#include <Xm/XrtNode.h>
#include <Xm/XrtNodeFolder.h>

static void build_tree(Widget w, const char *directory);

main(int argc, char *argv[]) {
  XtAppContext app_context;
  Widget toplevel, outliner;

  toplevel = XtAppInitialize(&app_context, "outliner", NULL, 0,
			     &argc, argv, NULL, NULL, 0);
  outliner = XtVaCreateManagedWidget("outliner", 
				     xmXrtOutlinerWidgetClass, 
				     toplevel, 
				     NULL);
  build_tree(outliner,".");
  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_context);

}

static void build_tree(Widget w, const char *start) {
  DIR *dir;
  struct dirent *de;
  struct stat statbuf;
  Widget folder;

  dir = opendir(start);
  if (strcmp(start,".") != 0)
    chdir(start);
  while (NULL != (de = readdir(dir))) { 
    if (strcmp(de->d_name,".") == 0 ||
	strcmp(de->d_name,"..") == 0) 
      continue;
    stat(de->d_name, &statbuf);
    if (S_ISDIR(statbuf.st_mode)) {
      folder = 
	XtVaCreateWidget(de->d_name,
			 xmXrtNodeFolderObjectClass, w,
			 XmNxrtGearLabel, XrtGearStringCreateCharString(de->d_name),
			 XmNxrtGearFolderStateMask, XRTGEAR_FOLDERSTATE_CLOSED);
			 NULL);
      build_tree(folder, de->d_name);
    } else if (S_ISREG(statbuf.st_mode)) {
      XtVaCreateWidget(de->d_name,
		       xmXrtNodeObjectClass, w,
		       XmNxrtGearLabel, XrtGearStringCreateCharString(de->d_name),
		       NULL);
    }
  }
  closedir(dir);
  if (strcmp(start,".") != 0)
     chdir("..");
}
