#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <time.h>
#include <locale.h>
#include <Xm/XrtGear.h>
#include <Xm/XrtOutliner.h>
#include <Xm/XrtNode.h>
#include <Xm/XrtNodeFolder.h>
#include <Xm/XrtColumn.h>
#include <Xm/XrtList.h>
#include <Xm/XrtGearString.h>

static void build_tree(Widget w, const char *directory);

main(int argc, char *argv[]) {
  XtAppContext app_context;
  Widget toplevel, outliner;

  setlocale(LC_TIME,"");
  toplevel = XtAppInitialize(&app_context, "outliner", NULL, 0,
			     &argc, argv, NULL, NULL, 0);
  outliner = XtVaCreateManagedWidget("outliner", 
				     xmXrtOutlinerWidgetClass, 
				     toplevel, 
				     XmNxrtGearColumnLabelsShow, True,
				     NULL);
  XtVaCreateWidget("col1",xmXrtColumnObjectClass, outliner, 
		   XmNxrtGearLabel, XrtGearStringCreateCharString("Name"),
		   NULL);
  XtVaCreateWidget("col2",xmXrtColumnObjectClass, outliner, 
		   XmNxrtGearLabel, XrtGearStringCreateCharString("Gre"),
		   XmNxrtGearLabelAlignment, XRTGEAR_ALIGN_END,
		   XmNxrtGearNodeAlignment, XRTGEAR_ALIGN_END,
		   NULL);
  XtVaCreateWidget("col3",xmXrtColumnObjectClass, outliner, 
		   XmNxrtGearLabel, XrtGearStringCreateCharString("Gendert"),
		   XmNxrtGearLabelAlignment, XRTGEAR_ALIGN_END,
		   XmNxrtGearNodeAlignment, XRTGEAR_ALIGN_END,
		   NULL);
  build_tree(outliner,".");
  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_context);

}

static void build_tree(Widget w, const char *start) {
  DIR *dir;
  struct dirent *de;
  struct stat statbuf;
  Widget folder;
  char size[20], time[50];
  struct tm *tptr;
  XrtGearObject list,str;

  dir = opendir(start);
  if (strcmp(start,".") != 0)
    chdir(start);
  while (NULL != (de = readdir(dir))) { 
    if (strcmp(de->d_name,".") == 0 ||
	strcmp(de->d_name,"..") == 0) 
      continue;
    stat(de->d_name, &statbuf);
    sprintf(size,"%1d",statbuf.st_size);
    tptr = localtime(&(statbuf.st_ctime));
    strftime(time,49,"%d.%b %y",tptr);
    list = XrtGearListCreate(sizeof(XrtGearObject));
    str = XrtGearStringCreateCharString(de->d_name);
    XrtGearListAppend(list,&str);
    if (S_ISDIR(statbuf.st_mode)) {
      str =XrtGearStringCreateCharString(" ");
      XrtGearListAppend(list,&str);
      str = XrtGearStringCreateCharString(time);
      XrtGearListAppend(list,&str );
      folder = 
	XtVaCreateWidget(de->d_name,
			 xmXrtNodeFolderObjectClass, w,
			 XmNxrtGearLabel, list,
			 NULL);
      build_tree(folder, de->d_name);
    } else if (S_ISREG(statbuf.st_mode)) {
      str = XrtGearStringCreateCharString(size);
      XrtGearListAppend(list, &str);
      str = XrtGearStringCreateCharString(time);
      XrtGearListAppend(list, &str);
      XtVaCreateWidget(de->d_name,
		       xmXrtNodeObjectClass, w,
		       XmNxrtGearLabel, list,
		       NULL);
    }
  }
  closedir(dir);
  if (strcmp(start,".") != 0)
     chdir("..");
}
