#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <time.h>
#include <locale.h>
#include <Xm/XrtGear.h>
#include <Xm/XrtAligner.h>
#include <Xm/XrtField.h>
#include <Xm/Label.h>

main(int argc, char *argv[]) {
  XtAppContext app_context;
  Widget toplevel, aligner;
  time_t today;
  static String dateformat[] = {"D.M.YYYY", NULL};

  setlocale(LC_ALL,"");
  toplevel = XtAppInitialize(&app_context, "aligner", NULL, 0,
			     &argc, argv, NULL, NULL, 0);
  aligner = XtVaCreateManagedWidget("aligner", 
				     xmXrtAlignerWidgetClass, 
				     toplevel, 
				     NULL);
  XtVaCreateManagedWidget("Datum", xmLabelWidgetClass,
			  aligner, 
			  XmNxrtGearAlignBaseline, False,
			  NULL);
  today = time(NULL);

  XtVaCreateManagedWidget("datumFld", xmXrtDateFieldWidgetClass,
			  aligner, 
			  XmNxrtGearAlignBaseline, False,
			  XmNxrtFldInternalValue, localtime(&today),
			  XmNxrtFldDisplayFormatString, dateformat[0],
			  XmNxrtFldDisplayFormat, XRTFLD_FORMAT_GENERAL,
			  XmNxrtFldEnterFormatList, dateformat,
			  NULL);
			  
  XtVaCreateManagedWidget("Stck", xmLabelWidgetClass,
			  aligner,
			  XmNxrtGearAlignBaseline, False,
			  NULL);
  XtVaCreateManagedWidget("stckFld", xmXrtIntFieldWidgetClass,
			  aligner, 
			  XmNxrtGearAlignBaseline, False,
			  XmNxrtFldInternalValue, 815,
			  XmNxrtFldMin, 815,
			  XmNxrtFldMax, 923, NULL);

  XtVaCreateManagedWidget("Betrag", xmLabelWidgetClass,
			  aligner, 
			  XmNxrtGearAlignBaseline, False,
			  NULL);
  XtVaCreateManagedWidget("betragFld", xmXrtCurrencyFieldWidgetClass,
			  aligner, 
			  XmNxrtGearAlignBaseline, False,
			  XmNxrtFldMin, XrtFldDoubleToArgVal(0.),
			  XmNxrtFldEditFormat, XRTFLD_FORMAT_CURRENCY,
			  NULL);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_context);

}

